# Retrieve a time series

Endpoint: GET /time-series/{twinId}
Version: v3
Security: oauth2

## Security:

  - `oauth2` (unknown)
    oauth2

## Path parameters:

  - `twinId` (string, required)
    Id of the twin

## Query parameters:

  - `start` (string, required)
    Start timestamp for the request

  - `end` (string, required)
    End timestamp for the request

  - `pageSize` (integer, required)
    Number of items returned per page (minimum 1)

  - `continuationToken` (string)
    Token for retrieving the next page of results

  - `includeDataQuality` (boolean)
    If true, include data quality metrics in the response

## Response 200:

  - `200` (unknown)
    OK

## Response 200 fields (application/json):

  - `data` (null | array)
    Gets or sets the data.

  - `data.connectorId` (null | string)
    Id of the connector

  - `data.twinId` (null | string)
    Id of the twin

  - `data.externalId` (null | string)
    External Id of the twin

  - `data.sourceTimestamp` (string)
    Timestamp when the source recorded the value in ISO 8601 format

  - `data.enqueuedTimestamp` (string)
    Timestamp when Willow received the value in ISO 8601 format

  - `data.scalarValue` (any)
    The data value being trended

  - `data.properties` (object)
    Properties or metadata about the observation or event being trended.

  - `data.dataQuality` (any)
    Data quality information.

  - `data.dataQuality.offline` (null | boolean)
    Indicates if the data is offline.

  - `data.dataQuality.valueOutOfRange` (null | boolean)
    Indicates if the value is out of range.

  - `data.dataQuality.sparse` (null | boolean)
    Indicates if the period is out of range.

  - `data.dataQuality.flatline` (null | boolean)
    Indicates if the data has flatlined.

  - `data.dataQuality.delayed` (null | boolean)
    Indicates if the data is delayed.

  - `continuationToken` (null | string)
    Gets or sets the continuation token.

  - `errorList` (any)
    Gets or sets the error list.

  - `errorList.message` (null | string)
    Gets or sets the error message.

  - `errorList.ids` (null | array)
    Gets or sets the IDs of the operation.

## Response 404:

  - `404` (unknown)
    Not Found

